Module javafx.base
Package javafx.beans.binding

# Class ListBinding<E>

java.lang.Object
javafx.beans.binding.ListExpression<E>
javafx.beans.binding.ListBinding<E>

Type Parameters:
  `E` - the type of the `List` element

All Implemented Interfaces:
  `Iterable<E>`, `Collection<E>`, `List<E>`, `Binding<ObservableList<E>>`, `Observable`, `ObservableListValue<E>`, `ObservableObjectValue<ObservableList<E>>`, `ObservableValue<ObservableList<E>>`, `ObservableList<E>`

    public abstract class ListBinding<E>
    extends ListExpression<E>
    implements Binding<ObservableList<E>>

Base class that provides most of the functionality needed to implement a `Binding` of an `ObservableList`.

`ListBinding` provides a simple invalidation-scheme. An extending class can register dependencies by calling `bind(Observable...)`. If one of the registered dependencies becomes invalid, this `ListBinding` is marked as invalid. With `unbind(Observable...)` listening to dependencies can be stopped.

To provide a concrete implementation of this class, the method `computeValue()` has to be implemented to calculate the value of this binding based on the current state of the dependencies. It is called when `get()` is called for an invalid binding.

See `DoubleBinding` for an example how this base class can be extended.

Since:
  JavaFX 2.1
See Also:
  `Binding`, `ListExpression`

- ## Property Summary

  ### Properties declared in class javafx.beans.binding.ListExpression

  `empty, size`

- ## Constructor Summary

  Constructors
  Constructor | Description
  --- | ---
  `ListBinding()` | Creates a default `ListBinding`.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `protected void` | `bind​(Observable... dependencies)` | Start observing the dependencies for changes.
  `protected abstract ObservableList<E>` | `computeValue()` | Calculates the current value of this binding.
  `void` | `dispose()` | A default implementation of `dispose()` that is empty.
  `ObservableList<E>` | `get()` | Returns the result of `computeValue()`.
  `ObservableList<?>` | `getDependencies()` | A default implementation of `getDependencies()` that returns an empty `ObservableList`.
  `protected void` | `onInvalidating()` | The method onInvalidating() can be overridden by extending classes to react, if this binding becomes invalid.
  `String` | `toString()` | Returns a string representation of this `ListBinding` object.
  `protected void` | `unbind​(Observable... dependencies)` | Stop observing the dependencies for changes.

  ### Methods declared in class javafx.beans.binding.ListExpression

  `asString, emptyProperty, getSize, isEqualTo, isNotEqualTo, isNotNull, isNull, listExpression, sizeProperty, valueAt, valueAt`

  ### Methods declared in class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods declared in interface javafx.beans.binding.Binding

  `invalidate, isValid`

  ### Methods declared in interface java.util.Collection

  `parallelStream, removeIf, stream, toArray`

  ### Methods declared in interface java.lang.Iterable

  `forEach`

  ### Methods declared in interface java.util.List

  `add, add, addAll, addAll, clear, contains, containsAll, equals, get, hashCode, indexOf, isEmpty, iterator, lastIndexOf, listIterator, listIterator, remove, remove, removeAll, replaceAll, retainAll, set, size, sort, spliterator, subList, toArray, toArray`

  ### Methods declared in interface javafx.beans.Observable

  `addListener, removeListener`

  ### Methods declared in interface javafx.collections.ObservableList

  `addAll, addListener, filtered, remove, removeAll, removeListener, retainAll, setAll, setAll, sorted, sorted`

  ### Methods declared in interface javafx.beans.value.ObservableValue

  `addListener, getValue, removeListener`

- ## Constructor Details

  - ### ListBinding

    public ListBinding()
    Creates a default `ListBinding`.

- ## Method Details

  - ### bind

    protected final void bind​(Observable... dependencies)
    Start observing the dependencies for changes. If the value of one of the dependencies changes, the binding is marked as invalid.
    Parameters:
      `dependencies` - the dependencies to observe

  - ### unbind

    protected final void unbind​(Observable... dependencies)
    Stop observing the dependencies for changes.
    Parameters:
      `dependencies` - the dependencies to stop observing

  - ### dispose

    public void dispose()
    A default implementation of `dispose()` that is empty.
    Specified by:
      `dispose` in interface `Binding<E>`

  - ### getDependencies

    public ObservableList<?> getDependencies()
    A default implementation of `getDependencies()` that returns an empty `ObservableList`.
    Specified by:
      `getDependencies` in interface `Binding<E>`
    Returns:
      an empty `ObservableList`

  - ### get

    public final ObservableList<E> get()
    Returns the result of `computeValue()`. The method `computeValue()` is only called if the binding is invalid. The result is cached and returned if the binding did not become invalid since the last call of `get()`.
    Specified by:
      `get` in interface `ObservableObjectValue<E>`
    Returns:
      the current value

  - ### onInvalidating

    protected void onInvalidating()
    The method onInvalidating() can be overridden by extending classes to react, if this binding becomes invalid. The default implementation is empty.

  - ### computeValue

    protected abstract ObservableList<E> computeValue()
    Calculates the current value of this binding.

    Classes extending `ListBinding` have to provide an implementation of `computeValue`.

    Returns:
      the current value

  - ### toString

    public String toString()
    Returns a string representation of this `ListBinding` object.
    Overrides:
      `toString` in class `Object`
    Returns:
      a string representation of this `ListBinding` object.